; #########################################################################

      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive

      include uChipCimu.inc        ; local includes for this file
      include dbmacros.asm
      include errormac.asm
      include eva.asm

.code

; #########################################################################

start:

      invoke InitCommonControls

    ; ------------------
    ; set global values
    ; ------------------
      invoke GetModuleHandle, NULL
      mov hInstance, eax

      invoke GetCommandLine
      mov CommandLine, eax

      invoke LoadIcon,hInstance,500    ; icon ID
      mov hIcon, eax

      invoke LoadCursor,NULL,IDC_ARROW
      mov hCursor, eax

      invoke GetSystemMetrics,SM_CXSCREEN
      mov sWid, eax

      invoke GetSystemMetrics,SM_CYSCREEN
      mov sHgt, eax

      call Main

      invoke ExitProcess,eax

; #########################################################################

Main proc

    LOCAL Wwd:DWORD,Wht:DWORD,Wtx:DWORD,Wty:DWORD

    STRING szClassName,"uChipClass"

    SingleInstanceOnly ADDR szClassName

  ; --------------------------------------------
  ; register class name for CreateWindowEx call
  ; --------------------------------------------
    invoke RegisterWinClass,ADDR WndProc,ADDR szClassName,
                       hIcon,hCursor,COLOR_BTNFACE+1

  ; -------------------------------------------------
  ; macro to autoscale window co-ordinates to screen
  ; percentages and centre window at those sizes.
  ; -------------------------------------------------
    AutoScale 75, 80

    invoke CreateWindowEx,WS_EX_LEFT,
                          ADDR szClassName,
                          ADDR szDisplayName,
                          WS_OVERLAPPEDWINDOW,
                          Wtx,Wty,Wwd,Wht,
                          NULL,NULL,
                          hInstance,NULL
    mov hWnd,eax

  ; ---------------------------
  ; macros for unchanging code
  ; ---------------------------
    DisplayWindow hWnd,SW_SHOWNORMAL

    call MsgLoop
    ret

Main endp

; #########################################################################

RegisterWinClass proc lpWndProc:DWORD, lpClassName:DWORD,
                      Icon:DWORD, Cursor:DWORD, bColor:DWORD

    LOCAL wc:WNDCLASSEX

    mov wc.cbSize,         sizeof WNDCLASSEX
    mov wc.style,          CS_BYTEALIGNCLIENT or \
                           CS_BYTEALIGNWINDOW
    m2m wc.lpfnWndProc,    lpWndProc
    mov wc.cbClsExtra,     NULL
    mov wc.cbWndExtra,     NULL
    m2m wc.hInstance,      hInstance
    m2m wc.hbrBackground,  bColor
    mov wc.lpszMenuName,   NULL
    m2m wc.lpszClassName,  lpClassName
    m2m wc.hIcon,          Icon
    m2m wc.hCursor,        Cursor
    m2m wc.hIconSm,        Icon

    invoke RegisterClassEx, ADDR wc

    ret

RegisterWinClass endp

; ########################################################################

MsgLoop proc

  ; ------------------------------------------
  ; The following 4 equates are available for
  ; processing messages directly in the loop.
  ; m_hWnd - m_Msg - m_wParam - m_lParam
  ; ------------------------------------------

    LOCAL msg:MSG

    StartLoop:
      invoke GetMessage,ADDR msg,NULL,0,0
      cmp eax, 0
      je ExitLoop
        mov eax, hWnd
        .if m_hWnd == eax
          .if m_Msg == WM_KEYUP
            .if m_wParam == VK_F1
              szText hlpMsg,"Hi, you pressed F1"
              invoke MessageBox,hWnd,ADDR hlpMsg,ADDR szDisplayName,MB_OK
            .endif
          .endif
        .endif
      invoke TranslateMessage, ADDR msg
      invoke DispatchMessage,  ADDR msg
      jmp StartLoop
    ExitLoop:

    mov eax, msg.wParam
    ret

MsgLoop endp

; #########################################################################

WndProc proc hWin   :DWORD,
             uMsg   :DWORD,
             wParam :DWORD,
             lParam :DWORD

	LOCAL lf	 :LOGFONT
    LOCAL var    :DWORD
    LOCAL caW    :DWORD
    LOCAL caH    :DWORD
    LOCAL Rct    :RECT
    LOCAL buffer1[128]:BYTE  ; these are two spare buffers
    LOCAL buffer2[128]:BYTE  ; for text manipulation etc..

    .if uMsg == WM_COMMAND
    ;======== toolbar commands ========
        .if wParam == 50
            invoke MessageBox,hWin,SADD("WM_COMMAND ID 50"),
                              ADDR szDisplayName,MB_OK

        .elseif wParam == 51
            invoke MessageBox,hWin,SADD("WM_COMMAND ID 51"),
                              ADDR szDisplayName,MB_OK

        .elseif wParam == 52
            invoke MessageBox,hWin,SADD("WM_COMMAND ID 52"),
                              ADDR szDisplayName,MB_OK

        .elseif wParam == 53
            invoke MessageBox,hWin,SADD("WM_COMMAND ID 53"),
                              ADDR szDisplayName,MB_OK

        .elseif wParam == 54
            invoke MessageBox,hWin,SADD("WM_COMMAND ID 54"),
                              ADDR szDisplayName,MB_OK

        .elseif wParam == 55
            invoke MessageBox,hWin,SADD("WM_COMMAND ID 55"),
                              ADDR szDisplayName,MB_OK

        .elseif wParam == 56
            invoke MessageBox,hWin,SADD("WM_COMMAND ID 56"),
                              ADDR szDisplayName,MB_OK

        .elseif wParam == 57
            invoke MessageBox,hWin,SADD("WM_COMMAND ID 57"),
                              ADDR szDisplayName,MB_OK

        .elseif wParam == 58
            invoke MessageBox,hWin,SADD("WM_COMMAND ID 58"),
                              ADDR szDisplayName,MB_OK
        .else
        	;*====	Check for controls	====
			mov		eax,wParam
			mov		edx,eax				
			and		eax,0FFFFh					; AX = control ID
			shr		edx,16						; DX = notification code
			
			.if edx==BN_CLICKED
				.if ax > 799 && ax < 827 
					cmp 	[RunState],1		; in ready mode?
					je		chkboxProc			; Yes, then process the checkbox
					
					;*====	In incorrect run state	====
					push	eax					; save the checkbox ID
					invoke	CheckDlgButton, hWin, eax, BST_UNCHECKED	;uncheck the checkbox
					
					cmp		[RunState],0		; in start mode?
					jne		chkboxAccept		; No, then must be in after accept mode
					
					;*====	In Start mode	====
		        	invoke  SendMessage,hStatus,SB_SETTEXT,0, offset szAcceptDone
					jmp		chkbxdone			;
					
					;*====	After accept mode	====
			chkboxAccept:
		        	invoke  SendMessage,hStatus,SB_SETTEXT,0, offset szClickNInstr
					jmp		chkbxdone			;
					
					;*====	Checkbox controls	====
			chkboxProc:
					sub		ebx,ebx				; clear EBX
					mov		edx,ebx				;  & EDX
					sub		eax,800				; EAX = clicked checkbox line number
					
					mov		[ClickLine],al		; save the clicked line #
					mov		bl,al				;  & in CL

					mov		ch,[CurLine]		; CH = current running line
					mov		al,[CurSet]			; AH = set count
					mov		cl,25				; 25 lines
					mul		cl
					sub		ch,al				; CH = actual line number in current set
					
					cmp		ch,bl				; is the current checkbox clicked?
					je		ldChkBox			; display error - wrong checkbox line
					
					;*====	Indicate error to user	====
					invoke 	MessageBox,hWin,ADDR szWrongLine,ADDR szDisplayName,MB_OK
		        	invoke  SendMessage,hStatus,SB_SETTEXT,0, offset szWrongLine
					jmp		chkbxdone			; exit
								
					;*====	Fetch clicked checkbox instruction information	=====
			ldChkBox:
					add		ebx,eax				; EBX = offset to instruction in list
					
					;*====	Load all the information in the list	====
					mov		al,[InstrList+ebx]	; AL = instruction
					mov		[CurInstr],al		; save it in memory
					
					mov		al,[IPortList+ebx]	; AL = Port name
					mov		[CurPort],al		; save it in memory
					
					mov		al,[IBitList+ebx]	; AL = bit name
					mov		[CurBit],al			; save it in memory
					
					mov		al,[IDataList+ebx]	; AL = Port data
					mov		[CurData],al		; save it in memory
					
					mov		al,[IDTypList+ebx]	; AL = data type
					mov		[CurDTyp],al		; save it in memory
		        	invoke  SendMessage,hStatus,SB_SETTEXT,0, offset szAcceptDone
					invoke	SetDlgItemText,hWin,902,offset szAccept	; 
	        		mov		[RunState],2		; in accept state
		chkbxdone:
				.elseif ax == 900				; new set button
					;inc		[CurSet]			; increment set count
				.elseif ax == 901				; new game button
				.elseif ax == 902				; accept button
					.if [RunState] == 0			; just started
						;*====	To start game	====
						invoke	SetDlgItemText,hWin,902,offset szClick	; 
		        		invoke  SendMessage,hStatus,SB_SETTEXT,0, offset szClickInstr
		        		
						;*====	Change button colour	=====
						invoke	InvalidateRect, hWin, NULL, TRUE

		        		mov		[RunState],1	; in running state
		        		invoke	SetTimer, hWin, 2, 1000,NULL
					.elseif [RunState] == 1		; running
						;*====	In running state and to accept changes made	====
						;*====	Check the port bits that have been changed	====
						invoke	SetDlgItemText,hWin,902,offset szClick	; 
		        		invoke  SendMessage,hStatus,SB_SETTEXT,0, offset szClickNInstr
						
		        		mov		al,[CurEnergy]	; AL = energy level
		        		mov		esi,offset szErrStr ; ESI -> string buffer
		        		call	cnv_b_ascii		; convert binary to ASCII
		        		invoke  SendMessage,hStatus,SB_SETTEXT,6, offset szErrStr
		        		
		        		mov		al,[CurSet]		; AL = set number
		        		mov		esi,offset szErrStr ; ESI -> string buffer
		        		call	cnv_b_ascii		; convert binary to ASCII
		        		invoke  SendMessage,hStatus,SB_SETTEXT,2, offset szErrStr

		        		mov		al,[CurGame]	; AL = game number
		        		mov		esi,offset szErrStr ; ESI -> string buffer
		        		call	cnv_b_ascii		; convert binary to ASCII
		        		invoke  SendMessage,hStatus,SB_SETTEXT,4, offset szErrStr
					.elseif [RunState] == 2		; processing instruction
						;*====	Processing instruction	====
						invoke	check_data,hWin	; check the changed data
		        		mov		[RunState],1	; in running state
		        		invoke	SetTimer, hWin, 2, 1000,NULL
					.endif
		        .endif
			.elseif edx == STN_DBLCLK
				mov		esi,offset szPort		; set to indicate which port was clicked
				sub		edx,edx					; default to Port 
				mov		cx,ax					; copy ID into ECX

				push	eax						; save ID

				.if ax > 699 && ax < 708
					;*====	Port A labels	====
					mov		edi,offset PortA_D	; ESI -> Port A data
					mov		al,[PortA_D]		; AL current port data
					sub		cx,700				; CL = bit position
					mov		byte ptr [esi],"A"	; insert Port A
				.elseif ax > 707 && ax < 716
					;*====	Port B labels	====
					mov		edi,offset PortB_D	; ESI -> Port A data
					mov		al,[PortB_D]		; AL current port data
					sub		cx,708				; CL = bit position
					mov		byte ptr [esi],"B"	; insert Port B
				.elseif ax > 715 && ax < 724
					;*====	Port C labels	====
					mov		edi,offset PortC_D	; ESI -> Port A data
					mov		al,[PortC_D]		; AL current port data
					sub		cx,716				; CL = bit position
					mov		byte ptr [esi],"C"	; insert Port C
				.elseif ax > 723 && ax < 733
					;*====	Port D labels	====
					mov		edi,offset PortD_D	; ESI -> Port A data
					mov		al,[PortD_D]		; AL current port data
					sub		cx,724				; CL = bit position
					mov		byte ptr [esi],"D"	; insert Port D
				.elseif ax > 749 && ax < 758
					;*====	TRIS A labels	====
					mov		dh,1				; default to TRIS click
					mov		esi,offset szTris	; set to indicate which tris was clicked
					mov		edi,offset TrisA_D	; ESI -> TRIS A data
					mov		al,[TrisA_D]		; AL current TRIS data
					sub		cx,750				; CL = bit position
					mov		byte ptr [esi],"A"	; insert Tris A
				.elseif ax > 757 && ax < 766
					;*====	TRIS B labels	====
					mov		dh,1				; default to TRIS click
					mov		esi,offset szTris	; set to indicate which tris was clicked
					mov		byte ptr [esi],"B"	; insert Tris B
					mov		edi,offset TrisB_D	; ESI -> TRIS B data
					sub		cx,758				; CL = bit position
					mov		al,[TrisB_D]		; AL current TRIS data
				.elseif ax > 765 && ax < 774
					;*====	TRIS C labels	====
					mov		dh,1				; default to TRIS click
					mov		esi,offset szTris	; set to indicate which tris was clicked
					mov		byte ptr [esi],"C"	; insert Tris C
					mov		edi,offset TrisC_D	; ESI -> TRIS C data
					sub		cx,766				; CL = bit position
					mov		al,[TrisC_D]		; AL current TRIS data
				.elseif ax > 773 && ax < 782
					;*====	TRIS D labels	====
					mov		dh,1				; default to TRIS click
					mov		esi,offset szTris	; set to indicate which tris was clicked
					mov		byte ptr [esi],"D"	; insert Tris D
					mov		edi,offset TrisD_D	; ESI -> TRIS D data
					sub		cx,774				; CL = bit position
					mov		al,[TrisD_D]		; AL current TRIS data
				.endif
		PortFnd:
				;*====	Toggle the data			====
				;*====	AL = Port/Tris data		====
				;*====	CL = Bit position		====
				;*====	ESI -> String to Port#	====
				;*====	EDI -> Port/Tris addr	====
				call	toggle_PTRIS			; toggle the bit

				;*====	Save Port/TRIS data	====
				mov		[edi],al				; save the port data
				pop		eax						; EDX = control ID
				push	dx						;
				invoke	SetDlgItemText,hWin,eax,esi	; 

				pop		dx
				.if dh == 0
					mov		al,[PortA_D]
					mov		esi,offset szPortAD
					call	disp_hex
								
					mov		al,[PortB_D]
					mov		esi,offset szPortBD
					call	disp_hex
								
					mov		al,[PortC_D]
					mov		esi,offset szPortCD
					call	disp_hex
								
					mov		al,[PortD_D]
					mov		esi,offset szPortDD
					call	disp_hex
					
					mov		esi,offset szPortData
				.else
					mov		al,[TrisA_D]
					mov		esi,offset szTrisAD
					call	disp_hex
								
					mov		al,[TrisB_D]
					mov		esi,offset szTrisBD
					call	disp_hex
								
					mov		al,[TrisC_D]
					mov		esi,offset szTrisCD
					call	disp_hex
								
					mov		al,[TrisD_D]
					mov		esi,offset szTrisDD
					call	disp_hex
					
					mov		esi,offset szTrisData
				.endif
		        invoke  SendMessage,hStatus,SB_SETTEXT,0, esi
		        invoke	SetTimer, hWin, 1, 2000,NULL
			.endif
		.endif
    .elseif uMsg == WM_CTLCOLORDLG
			invoke GetStockObject, WHITE_BRUSH

    .elseif uMsg == WM_CTLCOLORBTN
    	mov		eax,[hbAccept]
		.if lParam == eax && RunState == 1
			;.if [RunState] == 1
            ;invoke SetTextColor,wParam,00F0F0F0h    ; 00BBGGRR
			;invoke SetBkMode,wParam,TRANSPARENT
			;invoke GetStockObject,BLACK_BRUSH
			mov		eax,[YellowBrush]
			ret
			;.endif
		.endif

;		invoke SetTextColor, wParam, 0ff0000h
;		invoke GetStockObject, NULL_BRUSH

;		Send a WM_SETFONT to the static control to set the font.
;		Respond to a WM_CTLCOLORSTATIC message to set the colour.
;				invoke GetDlgItem,hWin,IDC_STATIC3
;				.if eax == lParam
;					invoke SetBkMode,wParam,TRANSPARENT
;					invoke SetTextColor,wParam,Blue
;					mov eax,YellowBrush
;					ret
;				.endif
;
;        .if eax == test001_static
;            invoke SetTextColor,wParam,00F0F0F0h    ; 00BBGGRR
;			invoke SetBkMode,wParam,TRANSPARENT
;			invoke GetStockObject,BLACK_BRUSH
;			ret

;      invoke GetDlgItem,hWin,IDC_TEXT
;       .IF eax==lParam      
;        invoke SetBkMode,wParam,1
;        invoke SetTextColor,wParam,Blue
;        invoke GetStockObject,LTGRAY_BRUSH
;        ret
;       .ENDIF

;hope that helps, it sets the text to blue, and you have to return, that way shows how to set it for one specific control, and not all of them
;if you want it for all static controls go like this:
;.ELSEIF uMsg==WM_CTLCOLORSTATIC
;        invoke SetBkMode,wParam,1
;        invoke SetTextColor,wParam,Blue
;        invoke GetStockObject,LTGRAY_BRUSH
;        ret


        
    .elseif uMsg == WM_CREATE
        invoke 	Do_Status,hWin
		call	start_status						; setup the status bar with information

         INVOKE     RtlZeroMemory, addr lf, sizeof lf
         INVOKE     lstrcpy, addr lf.lfFaceName, addr szFontName
            mov     lf.lfHeight, -8
            mov     lf.lfWeight, 400
         INVOKE     CreateFontIndirect, addr lf
            mov     hFont, eax   					; Tab font

		;*====	Set Tahoma font	====
		sub eax,eax
    	INVOKE 	CreateFont,-11,eax,eax,eax,eax,eax,eax,eax,eax,\
                      eax,eax,eax,eax,OFFSET szTahoma
                      
		invoke 	CreateSolidBrush,000FFFFh
            mov [YellowBrush],eax
            
		invoke 	CreateSolidBrush,0FFFF00h
            mov [RedBrush],eax
            
		invoke 	CreateSolidBrush,0FF00FFh
            mov [GreenBrush],eax
            
		;*====	Setup the form	====
		invoke	setup_form, hWin					; draw the form up - uChipfrm.asm

		call	InitRndmNbr							; initialize for random number

		;*====	Initialize variables	====		
		mov		[CurEnergy],10						; set current energy to 10
		mov		[RunState],0						; current running state: 0=boot up, 1=Running, 2=set completed
		mov		[CurLine],0							; start instruction line
		mov		[CurSet],0							; reset set count
		mov		[CurGame],0							; reset game count
		
		;*====	Randomize the instructions for game	====
		call	randomize							; randomize the command
		
		;*====	Display one page of instruction	====
		invoke	dsp_instr_page,hWin					; display one page of instruction
		
		;*====	Display current accept button instruction	====
		invoke	SetDlgItemText,hWin,902,offset szStart	; indicate start game
		
    .elseif uMsg == WM_SYSCOLORCHANGE

    .elseif uMsg == WM_SIZE
        invoke MoveWindow,hStatus,0,0,0,0,TRUE

    .elseif uMsg == WM_PAINT
        invoke Paint_Proc,hWin
        return 0

    .elseif uMsg == WM_TIMER
    	.if wParam== 1
    		invoke	KillTimer, hWin, 1				; kill timer
	        invoke  SendMessage,hStatus,SB_SETTEXT,0, offset szNull
    	.elseif wParam== 2
    		call	show_etime						; 
	        invoke  SendMessage,hStatus,SB_SETTEXT,8, offset MinStr
    	.endif
    .elseif uMsg == WM_CLOSE

    .elseif uMsg == WM_DESTROY
        invoke PostQuitMessage,NULL
        return 0

    .endif

    invoke DefWindowProc,hWin,uMsg,wParam,lParam

    ret

WndProc endp

; ########################################################################

TopXY proc wDim:DWORD, sDim:DWORD

    shr sDim, 1      ; divide screen dimension by 2
    shr wDim, 1      ; divide window dimension by 2
    mov eax, wDim    ; copy window dimension into eax
    sub sDim, eax    ; sub half win dimension from half screen dimension

    return sDim

TopXY endp

; #########################################################################

Paint_Proc proc hWin:DWORD

    LOCAL hDC      :DWORD
    LOCAL btn_hi   :DWORD
    LOCAL btn_lo   :DWORD
    LOCAL Rct      :RECT
    LOCAL Ps       :PAINTSTRUCT

    invoke BeginPaint,hWin,ADDR Ps
    mov hDC, eax

  ; ----------------------------------------

    invoke GetSysColor,COLOR_BTNHIGHLIGHT
    mov btn_hi, eax

    invoke GetSysColor,COLOR_BTNSHADOW
    mov btn_lo, eax

  ; ----------------------------------------

    invoke EndPaint,hWin,ADDR Ps

    ret

Paint_Proc endp

; ########################################################################


; ########################################################################

end start
